# VirtPlay
VirtPlay is a bash script to automate playing video or audio files over a fake PulseAudio microphone or fake v4l2loopback webcam.

## Depends
- [ffmpeg](https://ffmpeg.org/)
- [v4l2loopback](https://github.com/umlaeute/v4l2loopback)

## Installation
- Clone this repository
- Ensure that ~/.local/bin is in your PATH
- Copy virtplay to ~/.local/bin

## Options
| **Option**             | **Default**              | **Description**                                                                 |
|------------------------|--------------------------|---------------------------------------------------------------------------------|
| `-r` `--resolution`    | `1920x1080`              | Changes the resolution of the fake webcam                                       |
| `-f` `--fps`           | `30`                     | Changes the frame rate of the fake webcam                                       |
| `-b` `--border`        | `true`                   | Enables/disables changing the input video's aspect ratio to fit the fake webcam |
| `-l` `--loopback`      | `true`                   | Enables/disables playing the virtual microphone through your speakers           |
| `-ar` `--audio-rate`   | `44100`                  | Changes the audio sampling rate of the fake microphone                          |
| `-c` `--channels`      | `1`                      | Changes the number of audio channels the fake microphone has                    |
| `-ao` `--audio-only`   | `false`                  | Only uses the fake microphone                                                   |
| `-vo` `--video-only`   | `false`                  | Only uses the fake webcam                                                       |
| `-vd` `--video-device` | `/dev/video0`            | Changes which v4l2loopback device to use                                        |
| `-ad` `--audio-device` | `/run/user/$UID/virtmic` | Changes the path that the fake microphone pipe is created at                    |
| `-bf` `--buffer-file`  | `/tmp/virtplay`          | Changes the path that the stdin buffer file is created at                       |
| `-t` `--timestamp`     | `0`                      | Jumps play head to timestamp in either seconds or [HH:]MM:SS[.m...]             |
| `-v` `--volume`        | `1`                      | Sets the volume 0-1, where 0 is 0% and 1 is 100%                                |
| `-h` `--help`          |                          | Displays a help message                                                         |
